#include "context.hxx"
#include "cpp_gateway_prototype.hxx"
#include "sci_sundials.hxx"
extern "C"
{
#include "sci_sundials.h"
}

#define MODULE_NAME L"sci_sundials"

int sci_sundials(wchar_t* _pwstFuncName)
{
    if(wcscmp(_pwstFuncName, L"cvode") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"cvode", &sci_cvode, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"ida") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"ida", &sci_ida_solve, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"%_odeSolution_clear") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"%_odeSolution_clear", &sci_percent_odeSolution_clear, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"%_odeSolution_e") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"%_odeSolution_e", &sci_percent_odeSolution_e, MODULE_NAME)); }

    return 1;
}
